'-----------------------------------------------------------------------------------------
'name                     : pga2310_m8515_6in.bas
'copyright                : (c) danzup
'purpose                  : PGA Preamp controller
'micro                    : AtMega8515
'version                  : 1.6d
' this version with 6 input, RC5 remote control & PGA volume  ,
' mute ,backlight LED  control     ,
'  modified time delay for volume set
'-----------------------------------------------------------------------------------------
$regfile = "m8515.dat"                                      ' specify the used micro
$crystal = 8000000                                          ' used crystal frequency
$hwstack = 32                                               ' default use 32 for the hardware stack
$swstack = 10                                               ' default use 10 for the SW stack
$framesize = 40                                             ' default use 40 for the frame space
Ddrd = &B11000000                                           ' PD6...PD7 are output, PD0...PD5 are input
Portd = &B00111111                                          ' PD0...PD5 pull-up resistor enable
Ddra = &B11111111                                           ' PA0...PA7 are output ,input relay control
Ddrb = &B11111111                                           ' PB0...PB7 are output
Config Lcdpin = Pin , Db4 = Portc.2 , Db5 = Portc.3 , Db6 = Portc.4 , Db7 = Portc.5 , E = Portc.1 , Rs = Portc.0
Config Spi = Soft , Din = Portb.0 , Dout = Portb.1 , Ss = Portb.2 , Clock = Portb.4
Config Porta = Output
Config Portb.3 = Output                                     'mute line for PGA2310
Dim Address As Byte , Command As Byte                       'RC5 ir variable
Dim A As Bit                                                'first button  PortD.0
Dim B As Bit                                                'second button  PortD.4
Dim C As Bit                                                'third button   PortD.1
Dim D As Bit                                                'four button  PortD.5
Dim W As Word
Dim Inp_sel As Byte
Dim Pwr As Bit
Dim Mut As Bit
Dim Vol_out As Byte
Dim L As Byte
Dim R As Byte
Dim Gain As Single
Dim Gain1 As Single
L = 126
R = 126
Gain1 = -33
Reset Portb.3                                               'mute PGA2310
Declare Sub Spio
Declare Sub Shiftlf                                         'name say all for subroutine ...doh!!
Declare Sub Shiftrt
Declare Sub Volup
Declare Sub Voldn
Declare Sub Poweron
Declare Sub Poweroff
Declare Sub Af_sel
Declare Sub Pwr_onof
Declare Sub Mute
Cursor Off
On Int0 Pwr_oo                                              'we enable the INT0 interrupt
Enable Int0                                                 'we configure the INT0 interrupt to trigger when a falling edge is detected
Config Int0 = Falling
Config Lcd = 16 * 2                                         'other options are 16 * 4 and 20 * 4, 20 * 2 , 16 * 1a
Config Rc5 = Pind.3                                         'pin where is conected ir senzor
Set Portd.7
Spiinit                                                     'init the spi bus for PGA2310 talk with
Call Spio
Set Portb.3
Pwr = 0                                                     '0 =stand-by ; 1 = power on
Mut = 1                                                     ' 0 =mute , 1 = normal
Inp_sel = &B00000001                                        'default selected first input
Cls                                                         'clear the LCD display
Porta = Inp_sel                                             ' Will Set The Input Selected Default '
Lcd "Preamp controler"                                      'display this at the top line
Lowerline                                                   'select the lower line
Lcd "v=1.6d(c) danzup"
Wait 2
Cls
Enable Interrupts
 '--------------------------------------------------------------------------
If Pwr = 0 Then
Call Poweroff
End If
'--------------------------------------------------------------------------
Do
If Pwr = 1 Then
Getrc5(address , Command)                                   'read if we have remote ir command
  If Address = 0 Then
     Command = Command And &B01111111
  End If
Select Case Command
'---- this codes are for my remote , change code to your suit ! ----------------
   Case 32 : Call Shiftlf                                   'remote command code for CH up
   Case 33 : Call Shiftrt                                   'remote command code for CH down
   Case 17 : Call Voldn                                     'remote command code for Vol -
   Case 16 : Call Volup                                     'remote command code for Vol +
   Case 13 : Call Mute                                      'remote command code for Mute
   Case 12 : Call Pwr_onof                                  'remote command code for On/Off
End Select
A = Pind.0                                                  'if Pind.0 = 0 then we shift input_source left
B = Pind.4                                                  'if Pind.4 = 0 then we shift input_source right
D = Pind.1                                                  'if Pind.1 = 0 then we want to change volume  up
C = Pind.5                                                  'if Pind.5 = 0 then we want to change volume down
   If A = 0 Then                                            'now we read the push buttons for command
      Waitms 10
      Call Shiftlf                                          'button for left selection presed
   End If
   If B = 0 Then
      Waitms 10
      Call Shiftrt                                          'button for right selection presed
   End If
   If C = 0 Then                                            '
      Waitms 3
      Call Volup                                            'button for volume up presed
   End If
   If D = 0 Then
      Waitms 3
      Call Voldn                                            'button for volume down presed
   End If
End If

If Pwr = 0 Then
 Getrc5(address , Command)                                  'read if we have remote ir command
  If Address = 0 Then
     'clear the toggle bit
     'the toggle bit toggles on each new received command
     'toggle bit is bit 7. Extended RC5 bit is in bit 6
     Command = Command And &B01111111
  End If
 Select Case Command
 '---- this codes are for my remote , change code to your suit ! ----------------
   Case 12 : Call Pwr_onof                                  'remote command code for On/Off
 End Select
End If

Loop

End

'-----------INT 0 ----------------
Pwr_oo:
   Disable Int0
   Waitms 60
   Pwr = Not Pwr
   If Pwr = 1 Then
      Call Poweron
   Else
      Call Poweroff
   End If
   Enable Int0
Return

'-----------Pwr_onof-----------------
Sub Pwr_onof:

   Pwr = Not Pwr
   If Pwr = 1 Then
      Call Poweron
   Else
      Call Poweroff
   End If
End Sub

'------Poweron------------------------
Sub Poweron:

Set Portb.3                                                 'unmute  PGA2310
Set Portd.6                                                 'will set the Port D bit 6 to +5V power relay on
Set Portd.7                                                 'will set the Port D bit 7 to +5V backlight on

Display On                                                  'turn display on
Cls
Lcd "   Power On !   "
Wait 1
Cls
Porta = Inp_sel
Call Af_sel
Home Lowerline
If L > 192 Then
    Lcd "Volume +" ; Gain1 ; " dB "
Else
    Lcd "Volume " ; Gain1 ; " dB "
End If
Wait 2
End Sub
'-------Poweroff----------------------
Sub Poweroff:
Cls
Lcd "   Stand-By   "

Reset Portb.3                                               'mute PGA2310
Reset Portd.6                                               'will set the Port D bit 6 to 0V   power relay off
Reset Portd.7
Wait 2                                                      'will set the Port D bit 7 to 0V backlight off

Display Off                                                 'turn display off
Porta = &B00000000                                          ' mute
Wait 3
End Sub
'---------shift input Left----------
Sub Shiftlf:
Set Portd.7                                                 'will set the Port D bit 7 to +5V backlight on
W = 0
Timer1 = W
If Inp_sel >= 1 And Inp_sel < 32 Then
Rotate Inp_sel , Left
End If
Porta = Inp_sel
Call Af_sel
Wait 1
End Sub
'--------shift input right----------
Sub Shiftrt:
Set Portd.7                                                 'will set the Port D bit 7 to +5V backlight on
W = 0
Timer1 = W
If Inp_sel >= 2 And Inp_sel < 33 Then
Rotate Inp_sel , Right
End If
Porta = Inp_sel
Call Af_sel
Wait 1
End Sub
'-------bring volume up-----------
Sub Volup:
If L >= 86 Then
   If L = 256 Then
        L = 255
   End If
   If R = 256 Then
        R = 255
   End If
   Call Spio
        L = L + 1
        R = R + 1
        Gain = L / 2
        Gain1 = -96 + Gain
Else
   Call Spio
        L = L + 5
        R = R + 5
        Gain = L / 2
        Gain1 = -96 + Gain
End If
   Home Lowerline
If L > 192 Then
   Lcd "Volume +" ; Gain1 ; " dB "
Else
   Lcd "Volume " ; Gain1 ; " dB "
End If
   Waitms 1
End Sub

'--------bring volume down----------
Sub Voldn:
If L <= 86 Then
    If L = 1 Then
         L = 6
    End If
    If R = 1 Then
         R = 6
    End If
   Call Spio
        L = L - 5
        R = R - 5
        Gain = L / 2
        Gain1 = -96 + Gain
Else
   Call Spio
        L = L - 1
        R = R - 1
        Gain = L / 2
        Gain1 = -96 + Gain
End If
Home Lowerline
If L > 192 Then
   Lcd "Volume +" ; Gain1 ; " dB "
Else
   Lcd "Volume " ; Gain1 ; " dB "
End If
   Waitms 1
End Sub
'------Af_sel---------------------------
Sub Af_sel:
Home Upper
If Inp_sel = 1 Then
Lcd "DVD    selected"
End If
If Inp_sel = 2 Then
Lcd "CD     selected"
End If
If Inp_sel = 4 Then
Lcd "Tuner  selected"
End If
If Inp_sel = 8 Then
Lcd "Tape   selected"
End If
If Inp_sel = 16 Then
Lcd "Aux1   selected"
End If
If Inp_sel = 32 Then
Lcd "Aux2   selected"
End If
End Sub
'------- Mute ----------
Sub Mute:
   Mut = Not Mut
   If Mut = 1 Then
      Set Portb.3
      Porta = Inp_sel
      Home Lowerline
   If L > 192 Then
      Lcd "Volume +" ; Gain1 ; " dB "
   Else
      Lcd "Volume " ; Gain1 ; " dB "
   End If
      Wait 1
   Else
      Porta = &B00000000
      Reset Portb.3
      Home Lowerline
      Lcd "     MUTING      "
      Wait 1
   End If
End Sub
'-----Send data to PGA2310------
Sub Spio:
   Spiinit
   Spiout L , 1
   Spiout R , 1
End Sub
